unit U_WJGCKOutPut;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxStyles, cxCustomData, cxGraphics, cxFilter, cxData, cxDataStorage,
  cxEdit, DB, cxDBData, cxCalendar, cxDropDownEdit, ComCtrls, ToolWin,
  cxGridLevel, cxGridCustomTableView, cxGridTableView, cxGridDBTableView,
  cxClasses, cxControls, cxGridCustomView, cxGrid, cxGridCustomPopupMenu,
  cxGridPopupMenu, ADODB, DBClient, cxButtonEdit, cxTextEdit, cxSpinEdit,
  StdCtrls, ExtCtrls;

type
  TfrmWJGCKOutPut = class(TForm)
    ToolBar1: TToolBar;
    TBAdd: TToolButton;
    TBDel: TToolButton;
    TBSave: TToolButton;
    TBClose: TToolButton;
    DataSource3: TDataSource;
    CDS_Sub: TClientDataSet;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    ADOQueryTemp: TADOQuery;
    cxGridPopupMenu2: TcxGridPopupMenu;
    cxGrid2: TcxGrid;
    Tv1: TcxGridDBTableView;
    v1Column6: TcxGridDBColumn;
    v1Column2: TcxGridDBColumn;
    v1CRType: TcxGridDBColumn;
    v1Column13: TcxGridDBColumn;
    v1Column14: TcxGridDBColumn;
    v2Column1: TcxGridDBColumn;
    v1Column8: TcxGridDBColumn;
    v1Column7: TcxGridDBColumn;
    v1Column1: TcxGridDBColumn;
    v1Column10: TcxGridDBColumn;
    v1Column11: TcxGridDBColumn;
    v1Column9: TcxGridDBColumn;
    v2Column6: TcxGridDBColumn;
    v1Column3: TcxGridDBColumn;
    v1Column12: TcxGridDBColumn;
    cxGrid2Level1: TcxGridLevel;
    v1Column17: TcxGridDBColumn;
    v1Column19: TcxGridDBColumn;
    v1Column20: TcxGridDBColumn;
    Panel4: TPanel;
    Label14: TLabel;
    Panel10: TPanel;
    Image2: TImage;
    Button1: TButton;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    Button2: TButton;
    ToolButton1: TToolButton;
    v1Column4: TcxGridDBColumn;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TBAddClick(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBDelClick(Sender: TObject);
    procedure TBSaveClick(Sender: TObject);
    procedure v1Column1PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure v1Column11PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure v1Column5PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure Tv1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure Image2Click(Sender: TObject);
  private
    { Private declarations }
    function SaveCKData(): Boolean;
  public
    { Public declarations }
    FBCId: string;
  end;

var
  frmWJGCKOutPut: TfrmWJGCKOutPut;

implementation

uses
  U_DataLink, U_RTFun, U_ClothContractListHZCX, U_ZDYHelp, U_WJGCKKCSelList,
  U_GYSSelList, U_ZdyAttachGYS, U_ProductOrderListSel;

{$R *.dfm}

procedure TfrmWJGCKOutPut.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmWJGCKOutPut.TBAddClick(Sender: TObject);
begin
  try
    frmWJGCKKCSelList := TfrmWJGCKKCSelList.Create(Application);
    with frmWJGCKKCSelList do
    begin
      ToolButton1.Visible := True;
      if ShowModal = 1 then
      begin
        frmWJGCKKCSelList.CDS_Main.DisableControls;
        with frmWJGCKKCSelList.CDS_Main do
        begin
          First;
          while frmWJGCKKCSelList.CDS_Main.Locate('SSel', True, []) do
          begin
            with Self.CDS_Sub do
            begin
              Append;
              FieldByName('CRTime').Value := Trim(FormatDateTime('yyyy-MM-dd', Now));
              FieldByName('ORDMainIdRK').Value := Trim(frmWJGCKKCSelList.CDS_Main.fieldbyname('ORDMainIdRK').AsString);
              FieldByName('ORDSubIdRK').Value := Trim(frmWJGCKKCSelList.CDS_Main.fieldbyname('ORDSubIdRK').AsString);
              FieldByName('ORDMainIdCK').Value := Trim(frmWJGCKKCSelList.CDS_Main.fieldbyname('ORDMainIdRK').AsString);
              FieldByName('ORDSubIdCK').Value := Trim(frmWJGCKKCSelList.CDS_Main.fieldbyname('ORDSubIdRK').AsString);
              FieldByName('QCOrderNo').Value := frmWJGCKKCSelList.CDS_Main.fieldbyname('OrderNo').Value;
              FieldByName('CKOrderNo').Value := frmWJGCKKCSelList.CDS_Main.fieldbyname('OrderNo').Value;
              FieldByName('SPColor').Value := frmWJGCKKCSelList.CDS_Main.fieldbyname('SPColor').AsString;
              FieldByName('SPHX').Value := frmWJGCKKCSelList.CDS_Main.fieldbyname('SPHX').AsString;
              FieldByName('FactoryName').Value := frmWJGCKKCSelList.CDS_Main.fieldbyname('FactoryName').Value;
              FieldByName('FactoryNo').Value := frmWJGCKKCSelList.CDS_Main.fieldbyname('FactoryNo').Value;
              FieldByName('SpType').Value := frmWJGCKKCSelList.CDS_Main.fieldbyname('SpType').Value;
              FieldByName('spcode').Value := frmWJGCKKCSelList.CDS_Main.fieldbyname('spcode').Value;
              FieldByName('SPName').Value := frmWJGCKKCSelList.CDS_Main.fieldbyname('SPName').Value;
              FieldByName('SPSpec').Value := frmWJGCKKCSelList.CDS_Main.fieldbyname('SPSpec').Value;
              FieldByName('SPCF').Value := frmWJGCKKCSelList.CDS_Main.fieldbyname('SPCF').Value;
              FieldByName('batchno').Value := frmWJGCKKCSelList.CDS_Main.fieldbyname('batchno').Value;
              FieldByName('SPMF').Value := frmWJGCKKCSelList.CDS_Main.fieldbyname('SPMF').Value;
              FieldByName('SPKZ').Value := frmWJGCKKCSelList.CDS_Main.fieldbyname('SPKZ').Value;
              FieldByName('FromFactoryName').Value := frmWJGCKKCSelList.CDS_Main.fieldbyname('ToFactoryName').Value;
              FieldByName('FromFactoryNo').Value := frmWJGCKKCSelList.CDS_Main.fieldbyname('ToFactoryNo').Value;
              FieldByName('ToFactoryName').Value := frmWJGCKKCSelList.CDS_Main.fieldbyname('ToFactoryName').Value;
              FieldByName('ToFactoryNo').Value := frmWJGCKKCSelList.CDS_Main.fieldbyname('ToFactoryNo').Value;
              FieldByName('QtyUnit').Value := frmWJGCKKCSelList.CDS_Main.fieldbyname('QtyUnit').Value;
              FieldByName('PiQty').Value := frmWJGCKKCSelList.CDS_Main.fieldbyname('MXKCPiQty').Value;
              FieldByName('Qty').Value := frmWJGCKKCSelList.CDS_Main.fieldbyname('MXKCQty').Value;
              FieldByName('FZSPID').Value := frmWJGCKKCSelList.CDS_Main.fieldbyname('SPID').Value;
              FieldByName('GXNO').Value := frmWJGCKKCSelList.CDS_Main.fieldbyname('GXNO').AsInteger + 1;
            end;
            frmWJGCKKCSelList.CDS_Main.Delete;
          end;
        end;
        frmWJGCKKCSelList.CDS_Main.EnableControls;

      end;
    end;
  finally
    frmWJGCKKCSelList.Free;
  end;
end;

function TfrmWJGCKOutPut.SaveCKData(): Boolean;
var
  FCRID, Maxno, FSPID, MaxPYNo, FPYID: string;
begin
  try
    ADOQueryCmd.Connection.BeginTrans;
    CDS_Sub.DisableControls;
    with CDS_Sub do
    begin
      First;
      while not eof do
      begin
        with ADOQueryTemp do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from CK_SXPB_CR where SPID=''' + Trim(CDS_Sub.fieldbyname('SPID').AsString) + '''');
          Open;
        end;
        FSPID := Trim(ADOQueryTemp.fieldbyname('SPID').AsString);
        if Trim(FSPID) = '' then
        begin
          if GetLSNo(ADOQueryCmd, Maxno, 'WC', 'CK_SXPB_CR', 3, 1) = False then
          begin
            Result := False;
            ADOQueryCmd.Connection.RollbackTrans;
            Application.MessageBox('取外加工出库编号失败!', '提示', 0);
            Exit;
          end;
        end
        else
        begin
          Maxno := Trim(FSPID);
        end;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from CK_SXPB_CR where SPID=''' + Trim(Maxno) + '''');
          Open;
        end;
        with ADOQueryCmd do
        begin
          if Trim(FSPID) = '' then
          begin
            Append;
          end
          else
          begin
            Edit;
          end;
          FieldByName('SPID').Value := Trim(Maxno);
          FieldByName('ORDMainIdRK').Value := Trim(CDS_Sub.fieldbyname('ORDMainIdRK').AsString);
          FieldByName('ORDSubIdRK').Value := Trim(CDS_Sub.fieldbyname('ORDSubIdRK').AsString);
          FieldByName('ORDMainIdCK').Value := Trim(CDS_Sub.fieldbyname('ORDMainIdCK').AsString);
          FieldByName('ORDSubIdCK').Value := Trim(CDS_Sub.fieldbyname('ORDSubIdCK').AsString);
          FieldByName('FZSPID').Value := Trim(CDS_Sub.fieldbyname('FZSPID').AsString);
          FieldByName('FactoryNo').Value := Trim(CDS_Sub.fieldbyname('FactoryNo').AsString);
          FieldByName('FromFactoryNo').Value := Trim(CDS_Sub.fieldbyname('FromFactoryNo').AsString);
          FieldByName('ToFactoryNo').Value := Trim(CDS_Sub.fieldbyname('ToFactoryNo').AsString);
          FieldByName('GXNO').Value := Trim(CDS_Sub.fieldbyname('GXNO').AsString);
          FieldByName('CRFlag').Value := '出库';

          FieldByName('CRQtyFlag').Value := -1;
          RTSetSaveDataCDS(ADOQueryCmd, Tv1, CDS_Sub, 'CK_SXPB_CR', 2);
          FieldByName('CKName').Value := '外加工';
          if Trim(CDS_Sub.fieldbyname('CRType').AsString) = '平移出库' then
          begin
            FieldByName('PYID').Value := Trim(Maxno);
          end;
          if Trim(FSPID) = '' then
            FieldByName('Filler').Value := Trim(DName)
          else
          begin
            FieldByName('Editer').Value := Trim(DName);
            FieldByName('EditTime').Value := SGetServerDate(ADOQueryTemp);
          end;
          Post;
        end;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('Update CK_SXPB_CR Set MXKCQty=(select sum(isnull(Qty,0)*CRQtyFlag) from CK_SXPB_CR A where A.FZSPID=CK_SXPB_CR.SPID)');
          sql.Add(',MXKCPiQty=(select sum(isnull(PiQty,0)*CRQtyFlag) from CK_SXPB_CR A where A.FZSPID=CK_SXPB_CR.SPID)');
          sql.Add(' where SPID=''' + Trim(CDS_Sub.fieldbyname('FZSPID').AsString) + '''');
          ExecSQL;
        end;
        with ADOQueryTemp do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from CK_SXPB_CR where SPID=''' + Trim(CDS_Sub.fieldbyname('FZSPID').AsString) + '''');
          Open;
        end;
        if ADOQueryTemp.FieldByName('MXKCQty').Value < 0 then
        begin
          CDS_Sub.DisableControls;
          ADOQueryCmd.Connection.RollbackTrans;
          Application.MessageBox('出库数大于库存数不能保存!', '提示', 0);
          Exit;
        end;
        if Trim(CDS_Sub.fieldbyname('CRType').AsString) = '平移出库' then
        begin
          with ADOQueryTemp do
          begin
            Close;
            sql.Clear;
            sql.Add('select * from CK_SXPB_CR where PYID=''' + Trim(Maxno) + '''');
            sql.Add(' and isnull(CRType,'''')=''平移入库'' ');
            Open;
          end;
          FPYID := Trim(ADOQueryTemp.fieldbyname('SPID').AsString);
          if Trim(FPYID) = '' then
          begin
            if GetLSNo(ADOQueryCmd, MaxPYNo, 'YR', 'CK_SXPB_CR', 3, 1) = False then
            begin
              Result := False;
              ADOQueryCmd.Connection.RollbackTrans;
              Application.MessageBox('取外加工平移入库编号失败!', '提示', 0);
              Exit;
            end;
          end
          else
          begin
            MaxPYNo := Trim(FPYID);
          end;
          with ADOQueryCmd do
          begin
            Close;
            sql.Clear;
            sql.Add('select * from CK_SXPB_CR where SPID=''' + Trim(MaxPYNo) + '''');
            Open;
          end;
          with ADOQueryCmd do
          begin
            if Trim(FPYID) = '' then
            begin
              Append;
            end
            else
            begin
              Edit;
            end;
            FieldByName('SPID').Value := Trim(MaxPYNo);
            FieldByName('ORDMainIdRK').Value := Trim(CDS_Sub.fieldbyname('ORDMainIdCK').AsString);
            FieldByName('ORDSubIdRK').Value := Trim(CDS_Sub.fieldbyname('ORDSubIdCK').AsString);
            FieldByName('FZSPID').Value := Trim(MaxPYNo);
            FieldByName('FactoryNo').Value := Trim(CDS_Sub.fieldbyname('FactoryNo').AsString);
            FieldByName('FromFactoryNo').Value := Trim(CDS_Sub.fieldbyname('FromFactoryNo').AsString);
            FieldByName('ToFactoryNo').Value := Trim(CDS_Sub.fieldbyname('ToFactoryNo').AsString);
            FieldByName('CRFlag').Value := '入库';
            FieldByName('CRQtyFlag').Value := 1;
            RTSetSaveDataCDS(ADOQueryCmd, Tv1, CDS_Sub, 'CK_SXPB_CR', 2);
            FieldByName('CKName').Value := '外加工';
            FieldByName('CRType').Value := '平移入库';
            FieldByName('PYID').Value := Trim(Maxno);
            if Trim(FPYID) = '' then
              FieldByName('Filler').Value := Trim(DName)
            else
            begin
              FieldByName('Editer').Value := Trim(DName);
              FieldByName('EditTime').Value := SGetServerDate(ADOQueryTemp);
            end;
            Post;
          end;
          with ADOQueryCmd do
          begin
            Close;
            sql.Clear;
            sql.Add('Update CK_SXPB_CR Set MXKCQty=(select sum(isnull(Qty,0)*CRQtyFlag) from CK_SXPB_CR A where A.FZSPID=CK_SXPB_CR.SPID)');
            sql.Add(',MXKCPiQty=(select sum(isnull(PiQty,0)*CRQtyFlag) from CK_SXPB_CR A where A.FZSPID=CK_SXPB_CR.SPID)');
            sql.Add(' where SPID=''' + Trim(MaxPYNo) + '''');
            ExecSQL;
          end;
          with ADOQueryTemp do
          begin
            Close;
            sql.Clear;
            sql.Add('select * from CK_SXPB_CR where SPID=''' + Trim(MaxPYNo) + '''');
            Open;
          end;
          if ADOQueryTemp.FieldByName('MXKCQty').Value < 0 then
          begin
            CDS_Sub.DisableControls;
            ADOQueryCmd.Connection.RollbackTrans;
            Application.MessageBox('出库数大于库存数不能保存!', '提示', 0);
            Exit;
          end;
        end;
        Edit;
        FieldByName('SPID').Value := Trim(Maxno);
        Post;
        Next;
      end;
    end;
    CDS_Sub.EnableControls;
    ADOQueryCmd.Connection.CommitTrans;
    Result := True;
  except
    Result := False;
    ADOQueryCmd.Connection.RollbackTrans;
    Application.MessageBox('保存异常!', '提示', 0);
  end;

end;

procedure TfrmWJGCKOutPut.TBCloseClick(Sender: TObject);
begin
  WriteCxGrid('外加工出库登记PMD', Tv1, '外加工出库1');
  Close;
end;

procedure TfrmWJGCKOutPut.FormShow(Sender: TObject);
begin
  ReadCxGrid('外加工出库登记PMD', Tv1, '外加工出库1');
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add(' select A.* ');
    sql.Add(' ,OrderNo=(select OrderNo from JYOrder_Main JM where JM.MainId=A.OrdMainIdRK )');
    sql.Add(' ,OrderNoCK=(select OrderNo from JYOrder_Main JM where JM.MainId=A.OrdMainIdCK )');
    sql.Add(' from CK_SXPB_CR A');
    sql.Add(' where SPID=''' + Trim(FBCId) + '''');
    Open;
  end;
  SCreateCDS20(ADOQueryTemp, CDS_Sub);
  SInitCDSData20(ADOQueryTemp, CDS_Sub);
end;

procedure TfrmWJGCKOutPut.TBDelClick(Sender: TObject);
begin
  if CDS_Sub.IsEmpty then
    Exit;
  if Trim(CDS_Sub.fieldbyname('SPID').AsString) <> '' then
  begin
    with ADOQueryTemp do
    begin
      Close;
      sql.Clear;
      sql.Add('select * from CK_SXPB_CR where FZSPID=');
      sql.Add('(select SPID from CK_SXPB_CR where PYID=''' + Trim(CDS_Sub.fieldbyname('SPID').AsString) + '''');
      sql.Add(' and isnull(CRType,'''')=''平移入库'')');
      sql.Add(' and CRQtyFlag=-1');
      Open;
    end;
    if ADOQueryTemp.IsEmpty = False then
    begin
      Application.MessageBox('已有出库记录，不能删除!', '提示', 0);
      Exit;
    end;
    if Application.MessageBox('确定要删除数据吗？', '提示', 32 + 4) <> IDYES then
      Exit;
    try
      ADOQueryCmd.Connection.BeginTrans;

      with ADOQueryCmd do
      begin
        Close;
        sql.Clear;
        sql.Add(' delete CK_SXPB_CR where SPID=''' + Trim(CDS_Sub.fieldbyname('SPID').AsString) + '''');
        sql.Add(' Update CK_SXPB_CR Set MXKCQty=(select sum(isnull(Qty,0)*CRQtyFlag) from CK_SXPB_CR A where A.FZSPID=CK_SXPB_CR.SPID)');
        sql.Add(',MXKCPiQty=(select sum(isnull(PiQty,0)*CRQtyFlag) from CK_SXPB_CR A where A.FZSPID=CK_SXPB_CR.SPID)');
        sql.Add(' where SPID=''' + Trim(CDS_Sub.fieldbyname('FZSPID').AsString) + '''');
        {sql.Add('Update CK_SXPB_KC Set KCKGQty=(select sum(KGQty*CRQtyFlag) from CK_SXPB_CR A where A.CRID=CK_SXPB_KC.CRID)');
        sql.Add(',KCPiQty=(select sum(PiQty*CRQtyFlag) from CK_SXPB_CR A where A.CRID=CK_SXPB_KC.CRID)');
        sql.Add(' where CRID='+Trim(CDS_Sub.fieldbyname('CRID').AsString)); }
        ExecSQL;
      end;

      ADOQueryCmd.Connection.CommitTrans;
    except
      ADOQueryCmd.Connection.RollbackTrans;
      Application.MessageBox('删除异常!', '提示', 0);
    end;

  end;
  CDS_Sub.Delete;
end;

procedure TfrmWJGCKOutPut.TBSaveClick(Sender: TObject);
begin
  if CDS_Sub.IsEmpty then
    Exit;
  if CDS_Sub.Locate('CRTime', null, []) = True then
  begin
    Application.MessageBox('出库时间不能为空!', '提示', 0);
    Exit;
  end;
  if CDS_Sub.Locate('CRType', null, []) = True then
  begin
    Application.MessageBox('出库类型不能为空!', '提示', 0);
    Exit;
  end;
  if CDS_Sub.Locate('ToFactoryName', null, []) = True then
  begin
    Application.MessageBox('出到加工厂不能为空!', '提示', 0);
    Exit;
  end;
//  if CDS_Sub.Locate('CKOrderNo', null, []) = True then
//  begin
//    Application.MessageBox('出到订单号不能为空!', '提示', 0);
//    Exit;
//  end;
  if CDS_Sub.Locate('Qty', null, []) = True then
  begin
    Application.MessageBox('数量不能为空!', '提示', 0);
    Exit;
  end;
  if CDS_Sub.Locate('PiQty', null, []) = True then
  begin
    Application.MessageBox('匹数不能为空!', '提示', 0);
    Exit;
  end;
  CDS_Sub.DisableControls;
  with CDS_Sub do
  begin
    First;
    while not Eof do
    begin
      if Trim(CDS_Sub.fieldbyname('CRType').AsString) = '平移出库' then
      begin
        if (Trim(CDS_Sub.fieldbyname('FromFactoryName').AsString) = Trim(CDS_Sub.fieldbyname('ToFactoryName').AsString)) and (Trim(CDS_Sub.fieldbyname('ORDSubIdRK').AsString) = Trim(CDS_Sub.fieldbyname('ORDSubIdCK').AsString)) then
        begin
          CDS_Sub.EnableControls;
          Application.MessageBox('同一单号，同一工厂不能平移数据!', '提示', 0);
          Exit;
        end;
      end;
      Next;
    end;
  end;
  CDS_Sub.EnableControls;
  if SaveCKData() then
  begin
    Application.MessageBox('保存成功!', '提示', 0);
    //ModalResult:=1;
    Exit;
  end;
end;

procedure TfrmWJGCKOutPut.v1Column1PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmClothContractListHZCX := TfrmClothContractListHZCX.Create(Application);
    with frmClothContractListHZCX do
    begin
      if ShowModal = 1 then
      begin
        with Self.CDS_Sub do
        begin
          Edit;
          FieldByName('CGConNo').Value := Trim(frmClothContractListHZCX.Order_Main.fieldbyname('ConNo').AsString);
          FieldByName('CGConMainId').Value := Trim(frmClothContractListHZCX.Order_Main.fieldbyname('MainId').AsString);
          FieldByName('CGConSubId').Value := Trim(frmClothContractListHZCX.Order_Main.fieldbyname('SubId').AsString);
          FieldByName('FactoryName').Value := Trim(frmClothContractListHZCX.Order_Main.fieldbyname('FactoryNoName').AsString);
          FieldByName('SXName').Value := Trim(frmClothContractListHZCX.Order_Main.fieldbyname('C_CodeName').AsString);
          //Post;
        end;
      end;
    end;
  finally
    frmClothContractListHZCX.Free;
  end;
end;

procedure TfrmWJGCKOutPut.v1Column11PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmZdyAttachGYS := TfrmZdyAttachGYS.Create(Application);
    with frmZdyAttachGYS do
    begin
      if ShowModal = 1 then
      begin
        with Self.CDS_Sub do
        begin
          edit;
          FieldByName('ToFactoryNo').Value := Trim(frmZdyAttachGYS.CDS_HZ.fieldbyname('COCode').AsString);
          FieldByName('ToFactoryName').Value := Trim(frmZdyAttachGYS.CDS_HZ.fieldbyname('COName').AsString);
          //Post;
        end;
      end;
    end;
  finally
    frmZdyAttachGYS.Free;
  end;
end;

procedure TfrmWJGCKOutPut.v1Column5PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmProductOrderListSel := TfrmProductOrderListSel.Create(Application);
    with frmProductOrderListSel do
    begin
      if ShowModal = 1 then
      begin
        with Self.CDS_Sub do
        begin
          Edit;
          FieldByName('ORDMainIdCK').Value := Trim(frmProductOrderListSel.Order_Main.fieldbyname('MainId').AsString);
          FieldByName('ORDSubIdCK').Value := Trim(frmProductOrderListSel.Order_Main.fieldbyname('SubId').AsString);
          FieldByName('CKorderNo').Value := Trim(frmProductOrderListSel.Order_Main.fieldbyname('OrderNo').AsString);
//          FieldByName('SOrddefstr1').Value := Trim(frmProductOrderListSel.Order_Main.fieldbyname('SOrddefstr1').AsString);
          FieldByName('SPColor').Value := Trim(frmProductOrderListSel.Order_Main.fieldbyname('PRTColor').AsString);
          FieldByName('SPHX').Value := Trim(frmProductOrderListSel.Order_Main.fieldbyname('PRTHX').AsString);
        end;
      end;
    end;
  finally
    frmProductOrderListSel.Free;
  end;
end;

procedure TfrmWJGCKOutPut.Tv1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  FFSPID: string;
begin
  if CDS_Sub.IsEmpty then
    Exit;
  if Trim(CDS_Sub.fieldbyname('SPID').AsString) <> '' then
  begin
    with ADOQueryTemp do
    begin
      Close;
      sql.Clear;
      sql.Add('select * from CK_SXPB_CR where SPID=''' + Trim(CDS_Sub.fieldbyname('SPID').AsString) + '''');
      Open;
    end;
    FFSPID := Trim(ADOQueryTemp.fieldbyname('SPID').AsString);
    if Trim(FFSPID) <> '' then
    begin
      v1CRType.Options.Editing := False;
    end;
  end;
end;

procedure TfrmWJGCKOutPut.Button2Click(Sender: TObject);
var
  CRType, ORDMainIdCK, ORDSubIdCK, CKorderNo, ToFactoryName, KuWei, QtyUnit, Note: string;
  i, PiQty: Integer;
  qty: Double;
begin
  try
    if CDS_Sub.IsEmpty then
      Exit;
    CDS_Sub.DisableControls;
    with CDS_Sub do
    begin
      CRType := Trim(CDS_Sub.fieldbyname('CRType').AsString);
      ToFactoryName := Trim(CDS_Sub.fieldbyname('ToFactoryName').AsString);
      ORDMainIdCK := Trim(CDS_Sub.fieldbyname('ORDMainIdCK').AsString);
      ORDSubIdCK := Trim(CDS_Sub.fieldbyname('ORDSubIdCK').AsString);
      CKorderNo := Trim(CDS_Sub.fieldbyname('CKorderNo').AsString);
    end;
    with CDS_Sub do
    begin
      First;
      while not eof do
      begin
        Edit;
        if CheckBox1.Checked then
          FieldByName('CRType').Value := CRType;
        if CheckBox2.Checked then
          FieldByName('ToFactoryName').Value := ToFactoryName;
        if CheckBox3.Checked then
        begin
          FieldByName('ORDMainIdCK').Value := ORDMainIdCK;
          FieldByName('ORDSubIdCK').Value := ORDSubIdCK;
          FieldByName('CKorderNo').Value := CKorderNo;
        end;
        Post;
        Next;
      end;
    end;
    CDS_Sub.EnableControls;
  except
    Application.MessageBox('替换异常!', '提示', 0);
  end;
end;

procedure TfrmWJGCKOutPut.Button1Click(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to GroupBox1.ControlCount - 1 do
  begin
    if GroupBox1.Controls[i] is TCheckBox then
    begin
      TCheckBox(GroupBox1.Controls[i]).Checked := true;
    end;
  end;
end;

procedure TfrmWJGCKOutPut.ToolButton1Click(Sender: TObject);
begin
  Panel4.Visible := True;
end;

procedure TfrmWJGCKOutPut.Image2Click(Sender: TObject);
begin
  Panel4.Visible := False;
end;

end.

